(function(){
var _, _mid_ = "xge_fb_js";
// utils
var log= function() {
	var a= Array.prototype.slice.call(arguments);
	// a[0]= "["+_mid_+"]:"+a[0];
	a.unshift("["+_mid_+"]");
	console.log.apply(console, a);
}
var warn= function() {
	var a= Array.prototype.slice.call(arguments);
	// a[0]= "["+_mid_+"]:"+a[0];
	a.unshift("["+_mid_+"]");
	console.warn.apply(console, a);
}
// private API
var _cb_= {},
	_session_,
	_permissions_,
	_app_= null,
	_cnt_= 0,
	_active_= false,
	_ready_= [];

function reset() { _session_= _permissions_= null; }

function cnt(d) { return _cnt_+= (d||0); }
function event(e)
{
	var name= e.name||(e.name= "fbconnect");
	var cb= _cb_[name]||_cb_.fbinit;
	log("event >>", e);
	if(typeof(cb)==="function") cb(e);
	else if(_.dispatchEvent) 
		_.dispatchEvent({ f:cb, e:e });
	else 
		warn("no dispatchEvent method to deliver", cb, e);
	// if(typeof(cb)!=="function")
	// 	return warn("event:invalid cb", name, cb, _cb_);
	// else 
	// 	cb(e);
}

function tocb(cb)
{ 
	if(typeof(cb)==="function") 
		return cb;
	if(LuaIsFunction(cb)) {
		// log("tocb:callback -> lua", cb);
		return LuaCreateFunction(cb);
	}
	warn("tocb:not a function",cb);
	return cb;
}

function callback(cb, args)
{ 
	// log("callback", LuaIsFunction(cb), args);
	if(LuaIsFunction(cb)) cb= LuaCreateFunction(cb);
	
	if(typeof(cb)==="function") 
		cb.apply(this, args||[]);
	else 
		warn("callback:not a function",cb);
}

function loaded()
{
	// log("sdk loaded -> initialize");
	var FB= window.FB; 	if(!FB) 	return warn("loaded:no FB instance");
	var app= _app_;		if(!app) 	return warn("loaded:no APP config");

	reset();
	
	FB.Event.subscribe('auth.statusChange', fbStatus.bind(_, false, null));
	FB.init({
		version	: app.sdk,// SDK version
		appId 	: app.appId, // App ID
		status 	: true, // check login status
		cookie 	: true, // enable cookies to allow the server to access the session
		xfbml 	: true, // parse XFBML
		frictionlessRequests : true,
		status 	: true,
	});
	_active_= true;
	// log("app initializing..");
	event({ name:"fbinit", phase:"initialized" });
}

function fbStatus(forced,cb,r) 
{
	// log('status',r.status);

	if(r.status==='connected') 		fbRes(cb,"status", r);
	else if(forced==null || forced) connect(cb);
}
	
function fbRes(cb,label,r) 
{ //log('res:'+label, r);
	var data= r.authResponse,
		ok= data!=null,
		s= _session_||(_session_= {}),
		now= (Date.now()/1000)>>0;
	if(ok) {
		s.uid 			= data.userID;
		s.token 		= data.accessToken;
		s.expire 		= now + data.expiresIn;
		s.last 			= now;
		if(!_.connected) {
			fireConnect();
			if(!cb) 
				permissions(null, event.bind(this, { type:"session", phase:"restored", response:r }), false);
		}
	}
	if(cb) cb(r,ok);
	_.connected= ok;
}

function fireConnect()
{
	var s= _session_;
	// log("connected:fire", s && s.uid);
	if(!s || !s.token || !s.uid) return retryLogin();
	_.connected= true;
	
	// fire back ready state
	// log("connected:ready", _ready_);
	while(_ready_.length) callback( _ready_.shift() );

	// // CHECK ME
	// FB.api("/me?fields=name,picture", null, function(r) { log("me",r);
	// 	if(r.error && r.error.code==17) return;
	// 	var uname=_.name= r.name; 
	// 	_.img= (r.picture && r.picture.data) ? r.picture.data.url : null;
	// 	// CHECK FINAL
	// 	if(!uname) { log("[W]:me:failed"); return; }
	// 	// DONE
	// 	// _.set("connected",true);
	// 	_.connected= true;
	// 	// _.fire("me",{ uid:_.uid, name:_.name, img:_.img })
	// 	// run pool out
	// 	// var psz= API.apipool.length;  while(API.connected && psz--) API.apipool.shift()();
	// } ); 
}

var _tretry_= 0;
function retryLogin(cb, forced, scope)
{
	var t= _tretry_= (_tretry_||0.5)*2, dt= Math.floor((0.8 +  0.4*Math.random())*t*1000);
	log("retryLogin: will retry on",t,dt);
	var fin= login.bind(_, cb||fireConnect, (forced!=null ? forced : true), scope );
	return setTimeout(function(){ _.error= null; fin(); }, dt );
}

function login(cb, forced, scope)
{ //log('login', forced, scope);
	var FB= window.FB; 	if(!FB || _.error) 	return retryLogin(cb, forced, scope);
	FB.getLoginStatus(fbStatus.bind(_, forced, cb), true);
}

function connect(cb, forced, scope) 
{ //log("connect",forced);
	var FB= window.FB;
	if(!FB) return setTimeout( connect.bind(this,cb,forced,scope), 1000 );
	if(forced) connect.cnt=0;
	if(connect.cnt<0) connect.cnt=0;
	//log("connect #", connect.cnt); if(connect.cnt>0) return;
	connect.cnt = (connect.cnt||0)+1;
	_.connected= false;
	// API.set("connected",false); 	// reset status
	FB.login( function(r) { log('login <<',r.status, r.authResponse); connect.cnt--; 

		if(r) fbRes(cb,"login", r); 

	}, { scope:scope||(_app_ && _app_.scope), return_scopes: true });
}

function permissions(list, cb, ask) 
{
	var q= list && list.split(","),
		all= [], granted= [], denied= [];

	FB.api("/me/permissions",null, function(r){ //log("permissions <<",r);
		var p,id, d= r && r.data || r;

		if(!(d instanceof Array)) return warn("permission:invalid response",r);

		for(var i in d) if(p= d[i]) {
			all.push(id= p.permission);
			(p.status==="granted" ? granted : denied).push(id);
		}
		var x= q && q.filter(function(v){ return granted.indexOf(v)<0; });
		//log("permissions:miss", x);

		if(x && x.length>0 && ask) 
			FB.login(
				permissions.bind(this, list,cb, false), 
				{ scope:(x.join(",")), auth_type:"rerequest" }
			);
		else {
			_permissions_ = {
				declared: all.join(","),
				granted : granted.join(","),
				denied 	: denied.join(",")
			};
			if(cb) cb(_permissions_);
		}
	});
}

// public API
_= window[_mid_]=
{
	_callback : function(id, cb)
	{ 
		//log("callback", id, cb, LuaIsFunction(cb));
		if(LuaIsFunction(cb)) cb= LuaCreateFunction(cb);
		if(cb !== undefined) _cb_[id]= cb; return _cb_[id]; 
	},

	_isActive : function() 		{ return _active_; },
	_isConnected : function() 	{ return _.connected; },

	_init : function(cb, app)
	{ //log("init <<", arguments);
		if(_app_) return warn("already initialized");

		_._callback("fbinit", cb);
		_app_= app;
		//log("init",app);

		var fb= document.createElement('div');
		fb.id= "fb-root";
		document.body.prepend(fb);

		return (function(d, id, src, async, onload){
			var s="script", js, fjs = d.getElementsByTagName(s)[0]; //log("require:modules",d.getElementsByTagName(s));
			if(js=d.getElementById(id)) { warn("require:already exists",id); return js; }
			js = d.createElement(s); js.id = id;
			// fjs.parentNode.insertBefore(js, fjs);
			// document.head.appendChild(js);
			(d.head||d).appendChild(js);
			js.async = (async===true);
			js.onload = onload!=null ? onload : function() { log("module:loaded", id); };
			js.src = src;
			return js;
		}(document, "fb", "//connect.facebook.net/en_US/sdk.js", true, loaded));
	},
	
	_login : function(cb, scope)
	// login : function(/* [listener], [permissions] */)
	{
		// var cb= null, scope=null;
		// for(var i=0, n= arguments.length, a; i<n; i++)
		// 	if((a= arguments[i]) && typeof(a)==="function")
		// 		cb= a;
		// 	else if (a instanceof Array)
		// 		scope= a.join(",");
		// 	else if(typeof(a)==="string")
		// 		scope= a;
		if(cb) _._callback("fbconnect", cb);

		//log("login", cb, scope);
		if(scope instanceof Array) {
			scope= scope.join(",");
			//log("login:scope[] ->", scope);
		}

		login(function(r,ok){ //log("login <<", r,ok);
			// check permisions
			if(scope) permissions(scope, function(ps){ //log("login:permissions <<", ps);
				var v= ok ? "login" : ( r.error ? "loginfailed" : "logincancelled" );
				event({ type:"session", phase:v, response:r });
			}, true); 
		}, true, scope);
	},

	logout : function()
	{
		var FB= window.FB; 	if(!FB) return;
		FB.logout();
		_.connected= false;
		reset();
		event({ type:"session", phase:"logout" });
	},

	getCurrentAccessToken : function()
	{
		var a= _app_,
			s= _session_,
			p= _permissions_;

		if(window.FB) {
			var f= FB.getAuthResponse(),
				now= (Date.now()/1000)>>0;
			if(!f) return null;

			if(!s) s= _session_= {};
			s.uid= 		f.userID;
			s.token= 	f.accessToken;
			s.expire=	now + f.expiresIn;
		}

		return a && s && p && {
			appId 				: a.appId,
			userId 				: s.uid,
			token 				: s.token,
			expiration 			: s.expire,
			lastRefreshed 		: s.last,
			declinedPermissions : (p.denied  ||"").split(","),
			grantedPermissions  : (p.granted ||"").split(","),
		};
	},

	isFacebookAppEnabled 	: function() { return true; },
	publishInstall 			: function() {},
	_setFBConnectListener 	: function(cb) { _._callback("fbconnect", cb); },

	request : function(path, method, data)
	{ 
		_.api(path, method, data, function(r){
			var e= { type:"request", phase:path, response:r };
			if(r.error) {
				e.isError= true;
				e.errorType= r.error.code;
				e.errorString= r.error.message;
			}
			event(e);
		});
		// return _.api.apply(_, arguments); 
	},
	showDialog :function(action, params)
	{ 
		_.ui(action, params, function(r){
			var e= { type:"dialog", phase:action, response:r };
			if(r.error) {
				e.isError= true;
				e.errorType= r.error.code;
				e.errorString= r.error.message;
			}
			event(e);
		});
		// return  _.ui.apply(_, arguments); 
	},
	
	api : function(path, method, data, cb)
	{
		var method= method||"GET",
			cb= tocb(cb);

		//log("api", path, method, data);

		// var method= "GET", data= null, n= arguments.length;
		// if(n>2) 		{ method= arguments[1]; data= arguments[2]; }
		// else if(n>1) 	{ data= arguments[2]; }

		var FB= window.FB; if(!FB) return warn("request:no FB instance");

		var res= function(r) { //if(Math.irnd(0,1)) r={ error:"test error" };
			cnt(-1); //log("API:FB:api << ",path,data, r);
			if(!r) return warn("request:error:no response");

			if(r.error) { 
				if(r.error) _.error= r.error;
				warn("request:error", r.error.code, r.error.message, r); 
			}
			else {
				// reset error state
				_tretry_=0; _.error= null; 
			}
			// fire callback
			cb && callback(cb, [r]);
		}
		cnt(+1);
		if(data) 	FB.api(path, method, data, 	res);
		else 		FB.api(path, method, 		res);
	},

	ui :function(action, params, cb)
	{
		var FB= window.FB; if(!FB) return warn("dialog:no FB instance");

		var d= {
			method : (action==="requests" ? "apprequests" : action)
		};
		for(var i in params) d[i]= params[i];

		//log("dialog >> ",d);
		FB.ui(d, function(r){ log("dialog << ",r);
			// fire callback
			cb && callback(cb, [r]);
		});
	},

	purchase : function(item, cb)
	{
		if(!item) return warn("purchase:no item", item);
		var url= _app_.inapps + item;
		log("purchase >>",url);
		FB.ui({ method:'pay', action:'purchaseitem', product:url },	function(r) { 
			log("purchase <<",r); if(!r) return warn("purchase:fail")
			var t= {
				productIdentifier:item,
			},
				e= { 
				name:"fbpay",
				response:r,
				transaction:t
			};
			switch(r.status) {
				case "initiated": return;
				case "completed":
					t.state= "purchased";
					t.receipt= r.signed_request;
					t.data= new Date().toGMTString();
					t.identifier= r.payment_id.toString();
					break;
				default :
					t.isError= true;
					t.errorString= r.error_message;
					switch(t.errorType= r.error_code) {
						case 1383010: t.state= "cancelled"; break; 
					}
			}
			switch( typeof(cb) ) {
				case "function" : return cb(e);
				case "string" : e.name= cb;
				default: event(e);
			}
		});
	},

	ready : function(cb)
	{
		//log("on ready", LuaIsFunction(cb), cb);

		if(_._isConnected())
			callback(cb);
		else
			_ready_.push( tocb(cb) );
	},

	dump : function()
	{
		log("dump", _);
	},
};
log("loaded");
})();